import java.util.*;
import java.util.concurrent.*;


public class Main implements Runnable {

    private Counter counter = new Counter();

    public Main() {
	Thread t1 = new Thread(this, "Process 1");
	Thread t2 = new Thread(this, "Process 2");

	t1.start();
	t2.start();

	try {
	    t1.join();
	    t2.join();
	    System.out.println("Counter: "+counter);
	}
	catch (InterruptedException e) {
	}
    }

    public void run() {
	try {
	    for(int j = 0; j<10000000; j++) {
		// Thread.sleep(50 + (int)(Math.random()*100));
		// System.out.println(Thread.currentThread().getName()+" enters "+j);
		counter.increment();
	    }
	}
	catch (InterruptedException e) {
	}
    }

    public static void main(String[] args) {
	new Main();
    }
}



class Counter  {
    private int number = 0;
    private Semaphore mutex = new Semaphore(1); 
    
    //public synchronized void increment() {
    public void increment() throws InterruptedException {
       mutex.acquire() ;     
       number++; 
       mutex.release() ;
   }

    public String toString() {
	return ((Integer)number).toString();
    }
}
